Date: Sat, 29 Nov 1997 00:04:50 +0100 (CET)
From: Guenther Kelleter <guenther@Pool.Informatik.RWTH-Aachen.de>
Subject: RE: L68K: 2.0.29, Falcon+SM124
In-Reply-To: <Pine.OSF.3.93.971126123938.348A-100000@novice.uwaterloo.ca>
X-Sender: guenther@pc7390.dialup.rwth-aachen.de
To: Art Twarecki <atwareck@novice.uwaterloo.ca>
Cc: Linux68k-ML <linux-m68k@lists.linux-m68k.org>
X-Mime-Autoconverted: from QUOTED-PRINTABLE to 8bit by www.phil.uni-sb.de id AAA10930
Sender: owner-linux-m68k@phil.uni-sb.de
X-Mime-Autoconverted: from 8bit to quoted-printable by faui45.informatik.uni-erlangen.de id AAA23294

On Wed, 26 Nov 1997, Art Twarecki wrote:

> On Mon, 24 Nov 1997, Michael Schmitz wrote:
> 
> > >I sent this off a week ago, but never saw it on the list, so here's my
> > >question again:
> > 
> > Saw it (on the list or the newsgroup) but waited for a more competent person
> > to answer.
> 
> I must have missed it :(.
>  
> > >I find myself in need of specifying the video=keep option, otherwise
> > >immediately upon kernel startup, the SM124 screen goes blank.  Any clues?
> > 
> > What kernel version, and with what version first observed (what used before)?
> 
> 2.0.29 (it's in the subject field).  My VGA migrated to be used with an 
> Alpha, and I gave up my RGB, so I had no choice but the SM124.  This was
> recently, so I don't know what the behaviour is with older/newer kernels.
>  
> > I haven't used a SM124 on Falcon in ages so I don't know if that ever was
> > different, but you seem to suggest so. My guess is that the Falcon framebuffer
> > switches to some default VGA mode regardless of the monitor connected, but
> > then, I haven't looked at atafb.c for a long time so I don't know if the
> > monitor type should be detected (I'd guess so, but ...).
> 
> There is stuff in atafb.c for handling the monochrome mode.  I guess it
> just doesn't work well, or perhaps the problem is only on the falcon.
> I'll investigate once I have more time...
> 
> > Try video=sthigh for a change?
> 
> Thanks for the suggestion!  I'll give it a try.


Please try this fix, it avoids reprogramming the video controller if an
SM124 is attached. Its untested since I dont have an SM124.
The diff is for 2.1.64, but should also apply to 2.0.29+.


diff -urp -X exclude-linux -x exclude-linux m68k-2.1.64/drivers/video/atafb.c m68k-2.1.64.compile/drivers/video/atafb.c
--- m68k-2.1.64/drivers/video/atafb.c	Sun Nov 23 13:34:50 1997
+++ m68k-2.1.64.compile/drivers/video/atafb.c	Fri Nov 28 23:41:53 1997
@@ -1556,8 +1550,10 @@ static void falcon_set_par( struct atari
 	if (current_par.screen_base != par->screen_base)
 		fbhw->set_screen_base(par->screen_base);
 
-	/* Don't touch any other registers if we keep the default resolution */
-	if (DontCalcRes)
+	/* Don't touch any other registers if we keep the default resolution
+	 * or SM124 Monitor is used (hardware scrolling supported only)
+	 */
+	if (mon_type == F_MON_SM || DontCalcRes)
 		return;
 
 	/* Tell vbl-handler to change video mode.


Guenther
----
<guenther@pool.informatik.rwth-aachen.de>

